// ignore_for_file: camel_case_types, constant_identifier_names, non_constant_identifier_names, unnecessary_this
import './List.dart' as list_mod;

T defaultWith<T>(T Function() fn, T? opt) {
    if (opt != null) {
        return opt;
    } else {
        return fn();
    }
}

T? orElseWith<T>(T? Function() fn, T? opt) {
    if (opt != null) {
        return opt;
    } else {
        return fn();
    }
}

List<T> toArray<T>(T? opt) {
    if (opt != null) {
        return [opt];
    } else {
        return <T>[];
    }
}

list_mod.FSharpList<T> toList<T>(T? opt) {
    if (opt != null) {
        return list_mod.singleton(opt);
    } else {
        return list_mod.empty<T>();
    }
}

int count<T>(T? opt) {
    if (opt == null) {
        return 0;
    } else {
        return 1;
    }
}

bool contains<T>(T value, T? opt) {
    if (opt == null) {
        return false;
    } else {
        return value == opt;
    }
}

void iterate<T>(Function(T) fn, T? opt) {
    if (opt == null) {
    } else {
        fn(opt);
    }
}

bool forAll<T>(bool Function(T) fn, T? opt) {
    if (opt == null) {
        return true;
    } else {
        return fn(opt);
    }
}

bool exists<T>(bool Function(T) fn, T? opt) {
    if (opt == null) {
        return false;
    } else {
        return fn(opt);
    }
}

State fold<T, State>(State Function(State, T) folder, State state, T? opt) {
    if (opt == null) {
        return state;
    } else {
        return folder(state, opt);
    }
}

State foldBack<T, State>(State Function(T, State) folder, T? opt, State state) {
    if (opt == null) {
        return state;
    } else {
        return folder(opt, state);
    }
}

T? filter<T>(bool Function(T) fn, T? opt) {
    if (opt != null) {
        final opt_1 = opt;
        if (fn(opt_1)) {
            return opt_1;
        } else {
            return null;
        }
    } else {
        return null;
    }
}

U? map<T, U>(U Function(T) fn, T? opt) {
    if (opt != null) {
        return fn(opt);
    } else {
        return null;
    }
}

U? map2<T1, T2, U>(U Function(T1, T2) fn, T1? opt1, T2? opt2) {
    if ((opt1 != null) && (opt2 != null)) {
        return fn(opt1, opt2);
    } else {
        return null;
    }
}

U? map3<T1, T2, T3, U>(U Function(T1, T2, T3) fn, T1? opt1, T2? opt2, T3? opt3) {
    if ((opt1 != null) && ((opt2 != null) && (opt3 != null))) {
        return fn(opt1, opt2, opt3);
    } else {
        return null;
    }
}

U? bind<T, U>(U? Function(T) fn, T? opt) {
    if (opt != null) {
        return fn(opt);
    } else {
        return null;
    }
}

